/* Settings */
var topic_rss_feed = 'http://belmetal.org/rss/new'; // RSS  
var comments_rss_feed = 'http://belmetal.org/rss/allcomments/'; // RSS  
var events_rss_feed = 'http://belmetal.org/events/rss/'; // RSS  

var default_update_interval = 600000; //   RSS    (600000 = 10 )
var default_rss_count = 4; //    (4, 6, 8)
var default_theme = 'default'; //    (default, black)
/*---------------------------------------------------------------------------------------------------*/

/* Set the event handlers */
System.Gadget.settingsUI = "Settings.html";
System.Gadget.onSettingsClosed = settingsClosed;
System.Gadget.onDock = resizeGadget;
System.Gadget.onUndock = resizeGadget;

/* Load Start Setting */
function onLoadSetting()
{
	var LastFeedNumber = System.Gadget.Settings.read('LastFeedNumber');
	
	if(LastFeedNumber == '')
	{
		System.Gadget.Settings.write('LastFeedNumber', 1);
		LastFeedNumber = 1;
	}
	
	getNews(LastFeedNumber);

}

/* Refresh feed when Settings dialog is closed */
function settingsClosed(event)
{
	if (event.closeAction == event.Action.commit) 
	{
		loadTheme();
		onLoadSetting();
	}
}

/* Rezise gadget when docked/undocked */
function resizeGadget() 
{
	var themeName = System.Gadget.Settings.read('theme');
	noItems = System.Gadget.Settings.read('noItems');
	
	if ( noItems == "" ) noItems = default_rss_count;
	if ( themeName == "" ) themeName = default_theme;
	
	switch( noItems ) {
		case 4: 
			document.body.style.height = '209px'; 
			message.style.height = '142px';
			break;
		case 6: 
			document.body.style.height = '278px'; 
			message.style.height = '200px';
			break;
		case 8: 
			document.body.style.height = '348px'; 
			message.style.height = '280px';
			break;
	}
	
	for ( var i = 0; i < noItems; i++ ) document.getElementById(i).style.display = 'block';
	for ( var i = noItems; i < 8; i++ ) document.getElementById(i).style.display = 'none';
	
	if ( System.Gadget.docked == true )
	{
		try { document.body.style.background = "url('../themes/" + themeName + "/background" + noItems + ".png') no-repeat"; } catch(e) {}
		for ( var i = 0; i < noItems; i++ )
			document.getElementById(i+'').className = 'feedItemDocked';	
		message.style.width = '120px';
		navigation.style.marginLeft = '8px';
		titleLink.style.width = '75px';
		document.body.style.width = '132px';
	}
	else
	{
		try { document.body.style.background = "url('../themes/" + themeName + "/background-large" + noItems + ".png') no-repeat"; } catch(e) {}
		for ( var i = 0; i < noItems; i++ )
			document.getElementById(i+'').className = 'feedItemUndocked';
		message.style.width = '355px'; 
		navigation.style.marginLeft = '127px';
		titleLink.style.width = '308px';
		document.body.style.width = '368px';
	}
}

/* Create a new RSS item object */
function RSS2Item(itemxml)
{
	this.title;
	this.link;
	this.description;
	this.pubDate;

	var properties = new Array('title', 'link', 'description', 'pubDate');
	var tmpElement = null;
	for (var i=0; i<properties.length; i++)
	{
		tmpElement = itemxml.getElementsByTagName(properties[i])[0];
		if ( tmpElement != null )
			if ( tmpElement.childNodes != null )
				if ( tmpElement.childNodes[0] != null )
					if ( tmpElement.childNodes[0].nodeValue != null )
						eval('this.'+properties[i]+'=tmpElement.childNodes[0].nodeValue');
	}
}

/* Create a new RSS channel object */
function RSS2Channel(rssxml)
{
	this.items = new Array();
	var itemElements = rssxml.getElementsByTagName('item');
	for (var i=0; i<itemElements.length; i++)
	{
		Item = new RSS2Item(itemElements[i]);
		this.items.push(Item);
	}
}

/* Creates a new Atom feed entry object */
function AtomItem(itemxml)
{
	this.title;
	this.link;
	this.description;
	this.pubDate;

	try { this.title = itemxml.getElementsByTagName('title')[0].childNodes[0].nodeValue; }
	catch (e) { this.title = '(no title)'; }
	
	try { this.pubDate = itemxml.getElementsByTagName('published')[0].childNodes[0].nodeValue; }
	catch (e) { this.pubDate = null; }
	
	try { this.description = itemxml.getElementsByTagName('summary')[0].childNodes[0].nodeValue; }
	catch (e) { this.description = null; }
	
	if ( this.description == null ) 
	{
		try { this.description = itemxml.getElementsByTagName('content')[0].childNodes[0].nodeValue; }
		catch (e) { this.description = '(no summary)'; }
	}
	
	try 
	{
		var links = itemxml.getElementsByTagName('link');
		for ( var i = 0; i < links.length; i++ ) 
		{
			try { if ( links[i].attributes.getNamedItem('rel').value == 'alternate' ) this.link = links[i].attributes.getNamedItem('href').value }
			catch (e) {}
		}
	} catch(e) {}
}

/* Create a new Atom feed channel object */
function AtomChannel(atomxml)
{
	this.items = new Array();
	var itemElements;
	try { itemElements = atomxml.getElementsByTagName('feed')[0].getElementsByTagName('entry'); } catch (e) { return false; }

	for ( var i=0; i<itemElements.length; i++ )
	{
		Item = new AtomItem(itemElements[i]);
		this.items.push(Item);
	}	
}

/* Download (request) the feed from the URL */
function getNews(pRss)
{
	switch( pRss ) {
		case 1: 
			System.Gadget.Settings.write( 'feedName', '  ' );	
	        System.Gadget.Settings.write( 'feedURL', topic_rss_feed );	
			break;
		case 2: 
			System.Gadget.Settings.write( 'feedName', ' ' );
	        System.Gadget.Settings.write( 'feedURL', comments_rss_feed );
			break;
		case 3:
			System.Gadget.Settings.write( 'feedName', '  ' );
	        System.Gadget.Settings.write( 'feedURL', events_rss_feed );			
	}
	
	System.Gadget.Settings.write( 'LastFeedNumber', pRss );	
	document.getElementById('titleLink').onclick = function(){ getNews(pRss);};	
	var URL = System.Gadget.Settings.read('feedURL');

	showMessage( 'load' );
	currentPosition = 0;
	
 	var xmlDocument = new ActiveXObject('Microsoft.XMLDOM');
	xmlDocument.onreadystatechange = function () {
		if (xmlDocument.readyState == 4) {
			if ( xmlDocument.getElementsByTagName('item') != null ) news = new RSS2Channel(xmlDocument);
			else news = new AtomChannel(xmlDocument);
			if(news.items.length > 0) document.getElementById('online').style.display = 'none';
			else document.getElementById('online').style.display = 'block';
			showNews(news);
		}
	};
	xmlDocument.load(URL);
	
	SetOnlineInterval();
}

function SetOnlineInterval()
{
	var refreshTime = System.Gadget.Settings.read('refresh');
	if ( refreshTime > 0 ) UpdateInterval = setTimeout( 'getNews();', refreshTime );
	else UpdateInterval = setTimeout( 'getNews();', default_update_interval );
	clearTimeout(UpdateInterval-1);
}

/* Display the current 4 items in the news */
function showNews(news)
{
	var name = System.Gadget.Settings.read( 'feedName' );

	if(news.items.length > 0) System.Gadget.Settings.write( 'LastTitle', System.Gadget.Settings.read( 'feedName' ) );	
	
	if ( name != '' ) titleLink.innerHTML = name;
	else titleLink.innerHTML = '';
	var cnt = 0;
	for ( var i = currentPosition; (i < currentPosition+noItems) && (i < news.items.length); i++ ) 
	{
		var titles = news.items[i].title.replace(/^Comments\:/g, "");
		item_html = '<a ';
		item_html += (news.items[i].link == null) ? '' : 'href="javascript:void(0)" onclick="flyoutIndex = ' + i + '; showFlyout()">';
		item_html += (news.items[i].title == null ) ? '(no title)</a>' : titles + '</a>';
		item_html += (news.items[i].description == null) ? '' : '<br>' + decodeHTML(news.items[i].description);
		document.getElementById( (i-currentPosition) + '' ).innerHTML = item_html;
		System.Gadget.Settings.write('Rec-' + (i-currentPosition), item_html);
		cnt++;
	}
	if(cnt < 8 && news.items.length > 0)
	{
		for ( var a = cnt; a < 8; a++ ) 
			System.Gadget.Settings.write('Rec-'+a, '');	
	}
	showMessage("");
	return true;
}

/* Display a message to the user */
function showMessage( msg )
{
	message.style.visibility = 'visible';
	if ( msg == "" ) 
	{
		message.style.visibility = 'hidden';
		if(System.Gadget.Settings.read( 'LastTitle') == '') titleLink.innerHTML = '';
		else titleLink.innerHTML = System.Gadget.Settings.read('LastTitle');
		for ( var i = 0; i < 8; i++ ) 
			document.getElementById(i).innerHTML = System.Gadget.Settings.read('Rec-'+i);	
	}
}

/* Loads the current theme or the default one */
function loadTheme()
{
	var themeName = System.Gadget.Settings.read('theme');
	if ( themeName == '' ) themeName = default_theme;
	document.styleSheets(1).href = 'themes/' + themeName + '/style.css';
	resizeGadget();	
}

/* Show the flyout when mouse is over an item */
function showFlyout()
{
	if ( flyoutIndex >= news.items.length )
	{
		System.Gadget.Flyout.show = false;
		return true;
	}
	System.Gadget.Flyout.file = 'Flyout.html';
	System.Gadget.Flyout.show = true;
}

/* Clear the contents of the gadget */
function clear()
{
	for ( var i = 0; i < 8; i++ )
	{
		document.getElementById(i).innerHTML = '';
		System.Gadget.Settings.write('Rec-'+i, '');
	}
}

/* Converts &lt; and &gt; into < and > */
function decodeHTML(text)
{
	var ctom = /&lt;([^&]*)&gt;/g;
    return text.replace(ctom,'<$1>');
}

/* Scroll one page up */
function previousPage()
{
	currentPosition = (currentPosition - noItems >= 0) ? currentPosition - noItems : ((news.items.length - news.items.length%noItems)); 
	if ( currentPosition >= news.items.length ) currentPosition -= noItems;
	SetOnlineInterval();
	clear();
	showNews(news);
}

/* Scroll one page down */
function nextPage()
{
	currentPosition = (currentPosition + noItems) >= news.items.length ? 0 : (currentPosition + noItems);
	SetOnlineInterval();
	clear();
	showNews(news);
}

/* Current position in the feed */
var currentPosition = 0;

/* The index of the item that must be displayed in the flyout */
var flyoutIndex = 0;

/* The news items */
var news;

/* Number of items to display on a page */
var noItems = ( (System.Gadget.Settings.read('noItems') == '' ) ? default_rss_count : System.Gadget.Settings.read('noItems') );